# Mandelbrot Set 
[![Build Status](https://ci.paoda.moe/api/badges/paoda/mandelbrot/status.svg)](https://ci.paoda.moe/paoda/mandelbrot)
An interactive interface where you can navigate the Mandelbrot Set.

### Controls

#### 2D Movement
Key             | Action
---             | ---
<kbd>W</kbd>    | Up
<kbd>A</kbd>    | Left
<kbd>S</kbd>    | Down
<kbd>D</kbd>    | Right

#### Zoom
Key             | Action
---             | ---
<kbd>Q</kbd>    | Zoom Out
<kbd>E</kbd>    | Zoom In

#### 2D and Zoom Scale
Key             | Action
---             | ---
<kbd>R</kbd>    | Increase Scale
<kbd>F</kbd>    | Decrease Scale

#### Mandelbrot Iteration Limit (Can go up to 1024)
Key             | Action
---             | ---
<kbd>T</kbd>    | Increment by a factor of 2
<kbd>G</kbd>    | Decrement by a factor of 2



### Build Instructions
You can build the program with `cargo build`, or `cargo build --release` on stable.

### Run Instructions
You can either execute the compiled binary, or use `cargo run --release`


### TODO
- [x] Make Zooming feel more natural (where you zoom to is fixed, and not centred)
- [x] Make the amount of iterations done when calculating the Mandelbrot set configurable
- [x] Add smooth colouring 
    <!-- * Maybe look into histograms? -->
- [ ] Zoom with the Mouse?
- [ ] Automatically change scale? Remove the need for the user to deal with the Scale modifier